// SuperHover_sounds.cs

datablock AudioProfile(SuperHover_lightCrashSound)
{
   filename    = "./SK_lightCrash.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperHover_heavyCrashSound)
{
   filename    = "./SK_heavyCrash.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperHover_StartupSound)
{
   filename    = "./SK_start.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperHover_ShutOffSound)
{
   filename    = "./SK_off.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperHoverIdleSound)
{
   filename    = "./SKG_idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};
datablock AudioProfile(SuperHoverThrottle1Sound)
{
   filename    = "./SKG_idle1.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

package SuperHover_EngineSounds
{
   function armor::onMount(%this,%obj,%col,%a,%b)
   {
      Parent::onMount(%this,%obj,%col,%a,%b);
      if(%col.getDatablock().isSuperHover)
      {
         schedule(0,0,SuperHover_StartupAudio,%col);
         cancel(%col.audioLoop);
         %col.audioLoop = schedule(1800,0,SuperHover_startLoopAudio,%col);
      }
   }
   function armor::onUnMount(%this,%obj,%col)
   {
      Parent::onUnMount(%this,%obj,%col);
      if(%col.dataBlock.isSuperHover)
      {
         cancel(%col.audioLoop);
         schedule(0,0,SuperHover_StopLoopAudio,%col);
      }
   }
};

ActivatePackage(SuperHover_EngineSounds);

function SuperHover_StartupAudio(%veh)
{
   %veh.playAudio(0, SuperHover_StartupSound);
}
function SuperHover_StartLoopAudio(%veh)
{
   %veh.playAudio(0, SuperHoverIdleSound);
}
function SuperHover_StopLoopAudio(%veh)
{
   %veh.playAudio(0, SuperHover_ShutOffSound);
}

function SuperHoverSpeedCheck(%this, %obj)
{
	if(!isObject(%obj))
		return;
	%vehicle = %obj;
	%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());
	if(!%vehicle.oldSpeed)
	    %vehicle.oldSpeed = %speed;

	//Braking is not working currently
	if(%vehicle.oldSpeed)
	{
	    if(%vehicle.oldSpeed > %speed)
		%applyBrakes = true;
	    else if((%vehicle.oldSpeed - %speed) > 2) //Braking rate of speed in 500MS
		%applyBrakes = true;
	    if(%speed < 1)
		%applyBrakes = false;
	    else
		%applyBrakes = false;
	}

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;
	%vehicle.oldSpeed = %speed;
	//commandtoclient(%vehicle.getControllingClient(),'bottomprint', mFloor(%speed *2) @"<color:FFFF00>BPS", 1);

	//We use else if's so that it will find a true statement then skip the rest
	if(%speed < 5)
	    %vehicle.playAudio(%slot, SuperHoverIdleSound);
	else if(%speed < 20)
	    %vehicle.playAudio(%slot, SuperHoverThrottle1Sound);

	if(%applyBrakes)
	    %vehicle.playAudio(1, SuperHoverBreaksSound);
	if(!%applyBrakes)
	    %vehicle.stopAudio(1);
	    
	schedule(500,0,"SuperHoverSpeedCheck",%this,%obj);
}