// SuperKart_sounds.cs

datablock AudioProfile(SuperKart_lightCrashSound)
{
   filename    = "./SK_lightCrash.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperKart_heavyCrashSound)
{
   filename    = "./SK_heavyCrash.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperKart_StartupSound)
{
   filename    = "./SK_start.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperKart_ShutOffSound)
{
   filename    = "./SK_off.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(SuperKartIdleSound)
{
   filename    = "./SK_idle.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};
datablock AudioProfile(SuperKartThrottle1Sound)
{
   filename    = "./SK_idle1.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

package SuperKart_EngineSounds
{
   function armor::onMount(%this,%obj,%col,%a,%b)
   {
      Parent::onMount(%this,%obj,%col,%a,%b);
      if(%col.getDatablock().isSuperKart)
      {
         schedule(0,0,SuperKart_StartupAudio,%col);
         cancel(%col.audioLoop);
         %col.audioLoop = schedule(1800,0,SuperKart_startLoopAudio,%col);
      }
   }
   function armor::onUnMount(%this,%obj,%col)
   {
      Parent::onUnMount(%this,%obj,%col);
      if(%col.dataBlock.isSuperKart)
      {
         cancel(%col.audioLoop);
         schedule(0,0,SuperKart_StopLoopAudio,%col);
      }
   }
};

ActivatePackage(SuperKart_EngineSounds);

function SuperKart_StartupAudio(%veh)
{
   %veh.playAudio(0, SuperKart_StartupSound);
}
function SuperKart_StartLoopAudio(%veh)
{
   %veh.playAudio(0, SuperKartIdleSound);
}
function SuperKart_StopLoopAudio(%veh)
{
   %veh.playAudio(0, SuperKart_ShutOffSound);
}

function SuperKartSpeedCheck(%this, %obj)
{
	if(!isObject(%obj))
		return;
	%vehicle = %obj;
	%slot = 0; //Play the sound in the driver's spot
	%speed = vectorLen(%obj.getVelocity());
	if(!%vehicle.oldSpeed)
	    %vehicle.oldSpeed = %speed;

	//Braking is not working currently
	if(%vehicle.oldSpeed)
	{
	    if(%vehicle.oldSpeed > %speed)
		%applyBrakes = true;
	    else if((%vehicle.oldSpeed - %speed) > 2) //Braking rate of speed in 500MS
		%applyBrakes = true;
	    if(%speed < 1)
		%applyBrakes = false;
	    else
		%applyBrakes = false;
	}

	if(%speed < 0) //Keeps throwing random negative numbers when train is at dead stop
	    %speed = 0;
	%vehicle.oldSpeed = %speed;
	//commandtoclient(%vehicle.getControllingClient(),'bottomprint', mFloor(%speed *2) @"<color:FFFF00>BPS", 1);

	//We use else if's so that it will find a true statement then skip the rest
	if(%speed < 5)
	    %vehicle.playAudio(%slot, SuperKartIdleSound);
	else if(%speed < 20)
	    %vehicle.playAudio(%slot, SuperKartThrottle1Sound);

	if(%applyBrakes)
	    %vehicle.playAudio(1, SuperKartBreaksSound);
	if(!%applyBrakes)
	    %vehicle.stopAudio(1);
	    
	schedule(500,0,"SuperKartSpeedCheck",%this,%obj);
}